// Only for Debug to get logs within the xCode console

(function(){
  console.log = function (message) {
    window.webkit.messageHandlers.debug.postMessage(message);
  };
  console.warn = function (message) {
    window.webkit.messageHandlers.debug.postMessage(message);
  };
  console.error = function (message) {
    window.webkit.messageHandlers.debug.postMessage(message);
  };
})();

function onSmartWallSDKRequestedFromNative(params) {
    console.log("Called with value: " + params.apiKey);

    var sw = new SmartWallSDK({
      apiKey: params.apiKey,
      articleUid: params.articleUid,
      smartwallUid: params.smartwallUid,
      userUid: params.userUid,
      customVariables: params.customVariables,
      language: params.language,
      articleSelector: '.mainContainer',
      mode: 'ios',
      onUnlock: function() {
        const defaultUnlockResult = {unlocked: true}
        window.webkit.messageHandlers.onUnlockResult.postMessage(defaultUnlockResult);
      },
      onPaymentStart: function(data, error) {
        window.webkit.messageHandlers.onPaymentStart.postMessage({productId: data.productId});
      },
      onError: function(error) {
        console.log(JSON.stringify(error))
      }
    });
  
    var parent = document.querySelector(".sw-main").parentNode
    parent.style['max-width'] = '90%'
    
    window.smartWallSdk = sw;
}



function onPaymentCompletedInNative(purchaseInfo) {
  // this logging is added temporary for testing purpose only
  const purchaseInfoString = JSON.stringify(purchaseInfo)
  console.log('onPaymentCompletedInNative is called with params: ' + purchaseInfoString);
  

  window.smartWallSdk.checkPayment({"receipt-data": purchaseInfo.receipt, productId: purchaseInfo.productIdentifier})
    .then((response) => {
      console.log("Result checkPayment")
      console.log(JSON.stringify(response))
      
      if (response.status) {
        window.smartWallSdk.unlock();
      }
      
      window.webkit.messageHandlers.finishTransaction.postMessage({
        transactionIdentifier: purchaseInfo.transactionIdentifier,
        status: response.status
      });
    })
}
